<?
////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
////////////////////////////////////////////////////////////////////////
class SplitRenderer extends CardRenderer {
	public function render () {
		global $config;

		$card1 = $this->card;
		$card1->layout = "normal";//Render the frame normally then merge
		if ($config['output.english.title.on.translated.card'])	$card1->artist = $card1->title;


		$card2 = $card1->otherSplitHalf;
		$card2->layout = "normal";//Render the frame normally then merge
		if ($config['output.english.title.on.translated.card'])	$card2->artist = $card2->title;

		$r1 = $this->writer->getCardRenderer($card1);
		$image1 = $r1[0]->render();
		$image1tmp = imagerotate($image1, 90, 0);
		imagedestroy($image1);
		$image1 = $image1tmp;

		$r2 = $this->writer->getCardRenderer($card2);
		$image2 = $r2[0]->render();
		$image2tmp = imagerotate($image2, 90, 0);
		imagedestroy($image2);
		$image2 = $image2tmp;

		echo $this->card . '...';

		$canvas = imagecreatetruecolor(736, 1050);
		imagecopyresampled($canvas, $image1, 0, 1050 / 2, 0, 0, 736, 525, 1050, 736);
		imagecopyresampled($canvas, $image2, 0, 0, 0, 0, 736, 525, 1050, 736);
		imagedestroy($image1);
		imagedestroy($image2);

		echo "\n";
		return $canvas;
	}

	public function getSettings () {
		throw new Exception('SplitRenderer does not have settings.');
	}
	public function getCardName () {
		return $this->card->title . $this->card->otherSplitHalf->title;
	}
}

?>
